/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.125 by edhill, Sun Jul 10 00:15:49 2005 UTC revision 1.167 by jmc, Mon Nov 26 21:39:58 2007 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 248  build_cyrus_makedepend()  { Line 256  build_cyrus_makedepend()  {
256      fi      fi
257  }  }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 282  find_possible_configs()  { Line 325  find_possible_configs()  {
325    
326      #================================================================      #================================================================
327      #  look for possible C compilers      #  look for possible C compilers
328      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329      p_CC=      p_CC=
330      for c in $tmp ; do      for c in $tmp ; do
331          rm -f ./genmake_hello.c  ./genmake_hello          rm -f ./genmake_hello.c  ./genmake_hello
# Line 321  EOF Line 364  EOF
364    
365      #================================================================      #================================================================
366      #  look for possible FORTRAN compilers      #  look for possible FORTRAN compilers
367      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95 gfortran"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 353  EOF Line 396  EOF
396      else      else
397          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
398          echo "   "$p_FC          echo "   "$p_FC
399          if test "x$FC" = x ; then      fi
400              FC=`echo $p_FC | $AWK '{print $1}'`  
401              echo "  Setting FORTRAN compiler to: "$FC      #  Use the first of the compilers found in the current PATH
402          fi      #  that has a correctly-named optfile
403        if test "x$OPTFILE" = x  -a  "x$FC" = x ; then
404            for i in $p_FC ; do
405                OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406                if test -r $OPTFILE ; then
407                    echo "  Setting OPTFILE to: "$OPTFILE
408                    break
409                fi
410            done
411      fi      fi
412    
413      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
# Line 527  Usage: "$0" [OPTIONS] Line 578  Usage: "$0" [OPTIONS]
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587        -ts | --ts
588              Produce timing information per timestep
589        -papis | --papis
590              Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593        -foolad | --foolad
594              Fool the AD code generator
595        -papi | --papi
596              Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599        -hpmt | --hpmt
600              Performance analysis with the HPM Toolkit
601    
602        -gsl | --gsl
603              Use GSL to control floating point rounding and precision
604        -devel | --devel
605              Add additional warning and debugging flags for development
606    
607      -mpi | --mpi      -mpi | --mpi
608            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
609      -mpi=PATH | --mpi=PATH      -mpi=PATH | --mpi=PATH
# Line 534  Usage: "$0" [OPTIONS] Line 611  Usage: "$0" [OPTIONS]
611            set to PATH. i.e. Include files from \$PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
612            from \$PATH/lib and use binaries from \$PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
613    
614        -es | --es | -embed-source | --embed-source
615              Embed a tarball containing the full source code
616              (including the Makefile, etc.) used to build the
617              executable [off by default]
618    
619      -bash NAME      -bash NAME
620            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
621    
# Line 598  EOF Line 680  EOF
680        call tsub( string )        call tsub( string )
681        end        end
682  EOF  EOF
683      $FC $FFLAGS $DEFINES -c genmake_tcomp.$FS >> genmake_warnings 2>&1      $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
684      RETVAL=$?      RETVAL=$?
685      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
686          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 668  EOF Line 750  EOF
750      RET_C=$?      RET_C=$?
751      cat <<EOF > genmake_tc_2.$FS      cat <<EOF > genmake_tc_2.$FS
752        program hello        program hello
753        Real*8 wtime        REAL*8 wtime
754        external cloc        external cloc
755        call cloc(wtime)        call cloc(wtime)
756        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
757        end program hello        end
758  EOF  EOF
759      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
760        echo $COMM >> genmake_warnings
761        $COMM >> genmake_warnings 2>&1
762      RET_F=$?      RET_F=$?
763      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
764      RETVAL=$?      RETVAL=$?
# Line 686  EOF Line 770  EOF
770  }  }
771    
772    
773    check_HAVE_SIGREG()  {
774        if test ! "x$HAVE_SIGREG" = x ; then
775            return
776        fi
777        get_fortran_c_namemangling
778        cat <<EOF > genmake_tc_1.c
779    $FC_NAMEMANGLE
780    #include <stdlib.h>
781    #include <stdio.h>
782    #include <signal.h>
783    #include <errno.h>
784    #include <ucontext.h>
785    
786    int * ip;
787    
788    static void killhandler(
789        unsigned int sn, siginfo_t  si, struct ucontext *sc )
790    {
791        *ip = *ip + 1;
792        return;
793    }
794    
795    void FC_NAMEMANGLE(sigreg) (int * aip)
796    {
797        struct sigaction s;
798        ip = aip;
799        s.sa_flags = SA_SIGINFO;
800        s.sa_sigaction = (void *)killhandler;
801        if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
802            printf("Sigaction returned error = %d\n", errno);
803            exit(0);
804        }
805        return;
806    }
807    EOF
808        make genmake_tc_1.o >> genmake_warnings 2>&1
809        RET_C=$?
810        cat <<EOF > genmake_tc_2.$FS
811          program hello
812          integer anint
813          common /iv/ anint
814          external sigreg
815          call sigreg(anint)
816          end
817    EOF
818        echo >> genmake_warnings
819        echo "running: check_HAVE_SIGREG()" >> genmake_warnings
820        cat genmake_tc_2.$FS >> genmake_warnings
821        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
822        echo $COMM >> genmake_warnings
823        $COMM >> genmake_warnings 2>&1
824        RETVAL=$?
825        if test "x$RETVAL" = x0 ; then
826            HAVE_SIGREG=t
827            DEFINES="$DEFINES -DHAVE_SIGREG"
828        fi
829        rm -f genmake_tc*
830    }
831    
832    
833    check_HAVE_SETRLSTK()  {
834        if test "x$HAVE_SETRLSTK" = xt ; then
835            DEFINES="$DEFINES -DHAVE_SETRLSTK"
836            return
837        fi  
838        if test ! "x$HAVE_SETRLSTK" = x ; then
839            return
840        fi
841        get_fortran_c_namemangling
842        cat <<EOF > genmake_tc_1.c
843    $FC_NAMEMANGLE
844    #include <sys/time.h>
845    #include <sys/resource.h>
846    #include <unistd.h>
847    void FC_NAMEMANGLE(setrlstk) ()
848    {
849        struct rlimit rls;
850        rls.rlim_cur = RLIM_INFINITY;
851        rls.rlim_max = RLIM_INFINITY;
852        setrlimit(RLIMIT_STACK, &rls);
853        return;
854    }
855    EOF
856        make genmake_tc_1.o >> genmake_warnings 2>&1
857        RET_C=$?
858        cat <<EOF > genmake_tc_2.$FS
859          program hello
860          external setrlstk
861          call setrlstk()
862          end
863    EOF
864        echo >> genmake_warnings
865        echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
866        cat genmake_tc_2.$FS >> genmake_warnings
867        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
868        echo $COMM >> genmake_warnings
869        $COMM >> genmake_warnings 2>&1
870        RETVAL=$?
871        if test "x$RETVAL" = x0 ; then
872            HAVE_SETRLSTK=t
873            DEFINES="$DEFINES -DHAVE_SETRLSTK"
874        fi
875        rm -f genmake_tc*
876    }
877    
878    
879  check_HAVE_STAT()  {  check_HAVE_STAT()  {
880      get_fortran_c_namemangling      get_fortran_c_namemangling
881      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
# Line 714  EOF Line 904  EOF
904        integer nbyte        integer nbyte
905        call tfsize(nbyte)        call tfsize(nbyte)
906        print *," HELLO WORLD", nbyte        print *," HELLO WORLD", nbyte
907        end program hello        end
908  EOF  EOF
909      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_tc.log 2>&1      echo >> genmake_warnings
910      RET_F=$?      echo "running: check_HAVE_STAT()" >> genmake_warnings
911      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1      cat genmake_tc_2.$FS >> genmake_warnings
912        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
913        echo $COMM >> genmake_warnings
914        $COMM >> genmake_tc.log 2>&1
915      RETVAL=$?      RETVAL=$?
916      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
917          HAVE_STAT=t          HAVE_STAT=t
# Line 732  check_netcdf_libs()  { Line 925  check_netcdf_libs()  {
925      if test ! "x$SKIP_NETCDF_CHECK" = x ; then      if test ! "x$SKIP_NETCDF_CHECK" = x ; then
926          return          return
927      fi      fi
928      echo "" > genmake_tnc.log      echo >> genmake_warnings
929        echo "running: check_netcdf_libs()" >> genmake_warnings
930      cat <<EOF > genmake_tnc.F      cat <<EOF > genmake_tnc.F
931        program fgennc        program fgennc
932  #include "netcdf.inc"  #include "netcdf.inc"
# Line 750  EOF Line 944  EOF
944        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
945        end        end
946  EOF  EOF
947      echo "Executing:" > genmake_tnc.log      echo "===  genmake_tnc.F  ===" > genmake_tnc.log
948      echo "  $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS" \      cat genmake_tnc.F >> genmake_tnc.log
949          > genmake_tnc.log      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
950      RET_CPP=f      RET_CPP=f
951      $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
952          &&  RET_CPP=t      echo "$COMM" >> genmake_tnc.log
953        eval $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
954      if test "x$RET_CPP" = xf ; then      if test "x$RET_CPP" = xf ; then
955          echo "  WARNING: CPP failed to pre-process the netcdf test." \          echo "  WARNING: CPP failed to pre-process the netcdf test." \
956              > genmake_tnc.log              >> genmake_tnc.log
957          echo "    Please check that \$INCLUDES is properly set." \          echo "    Please check that \$INCLUDES is properly set." \
958              > genmake_tnc.log              >> genmake_tnc.log
959      fi      fi
960      echo "Executing:" > genmake_tnc.log      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
961      echo "  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS" > genmake_tnc.log      echo "  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
     echo "  $LINK -o genmake_tnc.o $LIBS" > genmake_tnc.log  
962      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
963          &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1          &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
964      RET_COMPILE=$?      RET_COMPILE=$?
965        cat genmake_tnc.log >> genmake_warnings
966    
967      #EH3  Remove test program execution for machines that either disallow      #EH3  Remove test program execution for machines that either disallow
968      #EH3  execution or cannot support it (eg. cross-compilers)      #EH3  execution or cannot support it (eg. cross-compilers)
# Line 780  EOF Line 975  EOF
975          HAVE_NETCDF=t          HAVE_NETCDF=t
976      else      else
977          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
978          $CPP $DEFINES $INCLUDES genmake_tnc.F > genmake_tnc.$FS 2>/dev/null  \          echo "try again with added '-lnetcdf'" > genmake_tnc.log
979            echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
980            echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
981            echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
982            cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
983              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
984              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1              &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
985          RET_COMPILE=$?          RET_COMPILE=$?
986            cat genmake_tnc.log >> genmake_warnings
987          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
988              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
989              HAVE_NETCDF=t              HAVE_NETCDF=t
990          else          else
991            # try again with "-lnetcdff" added to the libs
992                echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
993                echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
994                echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
995                echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
996                cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
997                    &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
998                    &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
999                RET_COMPILE=$?
1000              cat genmake_tnc.log >> genmake_warnings              cat genmake_tnc.log >> genmake_warnings
1001                if test "x$RET_COMPILE" = x0 ; then
1002                    LIBS="$LIBS -lnetcdff -lnetcdf"
1003                    HAVE_NETCDF=t
1004                fi
1005          fi          fi
1006      fi      fi
1007      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 824  OPTFILE= Line 1037  OPTFILE=
1037  INCLUDES="-I. $INCLUDES"  INCLUDES="-I. $INCLUDES"
1038  FFLAGS=  FFLAGS=
1039  FOPTIM=  FOPTIM=
1040    FEXTRAFLAGS=
1041  CFLAGS=  CFLAGS=
1042  KFLAGS1=  KFLAGS1=
1043  KFLAGS2=  KFLAGS2=
# Line 834  NOOPTFILES= Line 1048  NOOPTFILES=
1048  NOOPTFLAGS=  NOOPTFLAGS=
1049  MPI=  MPI=
1050  MPIPATH=  MPIPATH=
1051    TS=
1052    PAPIS=
1053    PCLS=
1054    FOOLAD=
1055    PAPI=
1056    PCL=
1057    HPMT=
1058    GSL=
1059    DEVEL=
1060    HAVE_TEST_L=
1061    
1062  # DEFINES checked by test compilation or command-line  # DEFINES checked by test compilation or command-line
1063  HAVE_SYSTEM=  HAVE_SYSTEM=
1064  HAVE_FDATE=  HAVE_FDATE=
1065  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1066  HAVE_CLOC=  HAVE_CLOC=
1067    # HAVE_SETRLSTK=
1068  HAVE_STAT=  HAVE_STAT=
1069  HAVE_NETCDF=  HAVE_NETCDF=
1070  HAVE_ETIME=  HAVE_ETIME=
# Line 856  BASH= Line 1081  BASH=
1081  PWD=`pwd`  PWD=`pwd`
1082  test "x$MAKE" = x  &&  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1083  test "x$AWK" = x   &&  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1084    EMBED_SRC=
1085  THISHOST=`hostname`  THISHOST=`hostname`
1086  THISCWD=`pwd`  THISCWD=`pwd`
1087  THISDATE=`date`  THISDATE=`date`
# Line 889  TAMC_EXTRA= Line 1115  TAMC_EXTRA=
1115    
1116  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1117  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1118  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1119    
1120  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1121  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM FEXTRAFLAGS"
1122  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1123  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1124  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
# Line 919  EOF Line 1145  EOF
1145    
1146  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
1147  gm_local="genmake_local"  gm_local="genmake_local"
 for i in . $MODS ; do  
     if test -r $i/$gm_local ; then  
         . $i/$gm_local  
         break  
     fi  
 done  
1148  printf "  getting local config information:  "  printf "  getting local config information:  "
1149  if test -f $gm_local ; then  if test -f $gm_local ; then
1150      echo "using $gm_local"      echo "using $gm_local"
# Line 1069  for ac_option in "$@" ; do Line 1289  for ac_option in "$@" ; do
1289          -noieee | --noieee)          -noieee | --noieee)
1290              IEEE= ;;              IEEE= ;;
1291    
1292            -ts | --ts)
1293                TS=true ;;
1294            -papis | --papis)
1295                PAPIS=true ;;
1296            -pcls | --pcls)
1297                PCLS=true ;;
1298            -foolad | --foolad)
1299                FOOLAD=true ;;
1300            -papi | --papi)
1301                PAPI=true ;;
1302            -pcl | --pcl)
1303                PCL=true ;;
1304            -hpmt | --hpmt)
1305                HPMT=true ;;
1306    
1307            -gsl | --gsl)
1308                GSL=true ;;
1309    
1310            -devel | --devel)
1311                DEVEL=true ;;
1312    
1313          -mpi | --mpi)          -mpi | --mpi)
1314              MPI=true ;;              MPI=true ;;
1315          -mpi=* | --mpi=*)          -mpi=* | --mpi=*)
# Line 1096  for ac_option in "$@" ; do Line 1337  for ac_option in "$@" ; do
1337          -ignoretime | -ignore_time | --ignoretime | --ignore_time)          -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1338              IGNORE_TIME="-DIGNORE_TIME" ;;              IGNORE_TIME="-DIGNORE_TIME" ;;
1339    
1340            -es | --es | -embed-source | --embed-source)
1341                EMBED_SRC=t ;;
1342    
1343          -*)          -*)
1344              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
1345              usage              usage
# Line 1114  done Line 1358  done
1358  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1359      echo      echo
1360      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1361      echo "  file.  This file format is no longer supported.  Please see:"      echo "  file.  This file format is no longer supported.  For directions on"
1362      echo      echo "  how to setup and use the new \"genmake2\" script, please see:"
1363      echo "    http://mitgcm.org/devel_HOWTO/"      echo "    http://mitgcm.org/devel_HOWTO/"
1364      echo      echo "  and send an email to MITgcm-support@mitgcm.org if you need help."
1365      echo "  for directions on how to setup and use the new \"genmake2\" input"      echo "WARNING: ignore \"./.genmakerc\" and continue."
     echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."  
1366      echo      echo
1367  fi  fi
1368    
1369  #  Find the MITgcm ${ROOTDIR}  #  Find the MITgcm ${ROOTDIR}
1370  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1371      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1372      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1373          ROOTDIR=".."          ROOTDIR=".."
1374      else      else
1375          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 1294  Error: The command "ln -s" failed -- ple Line 1537  Error: The command "ln -s" failed -- ple
1537  EOF  EOF
1538      exit 1      exit 1
1539  fi  fi
1540    test -L genmake_tlink > /dev/null 2>&1
1541    RETVAL=$?
1542    if test "x$RETVAL" = x0 ; then
1543        HAVE_TEST_L=t
1544    fi
1545  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1546    
1547  #  Check for broken *.F/*.f handling and fix if possible  #  Check for broken *.F/*.f handling and fix if possible
# Line 1304  if test ! "x$MPI" = x ; then Line 1552  if test ! "x$MPI" = x ; then
1552        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1553  fi  fi
1554    
1555    if test ! "x$TS" = x ; then
1556          echo "  Turning on timing per timestep"
1557          if test ! "x$FOOLAD" = x ; then
1558                DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1559          else
1560                DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1561          fi
1562          PACKAGES="$PACKAGES showflops"
1563    fi
1564    if test ! "x$PAPIS" = x ; then
1565          echo "  Turning on PAPI flop summary per timestep"
1566          echo "  Please make sure PAPIINC, PAPILIB are defined"
1567          if test ! "x$FOOLAD" = x ; then
1568                DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1569          else
1570                DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1571          fi
1572          INCLUDES="$INCLUDES $PAPIINC"
1573          LIBS="$LIBS $PAPILIB"
1574          PACKAGES="$PACKAGES showflops"
1575    fi
1576    if test ! "x$PCLS" = x ; then
1577          echo "  Turning on PCL counter summary per timestep"
1578          echo "  Please make sure PCLINC, PCLLIB are defined"
1579          if test ! "x$FOOLAD" = x ; then
1580                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1581          else
1582                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1583          fi
1584          INCLUDES="$INCLUDES $PCLINC"
1585          LIBS="$LIBS $PCLLIB"
1586          PACKAGES="$PACKAGES showflops"
1587    fi
1588    if test ! "x$PAPI" = x ; then
1589          if test ! "x$PAPIS" = x ; then
1590              echo "  PAPI performance analysis and flop summary per timestep cannot co-exist!"
1591              echo "  Sticking with PAPI flop summary per timestep!"
1592          else
1593              echo "  Turning on performance analysis with PAPI"
1594              echo "  Please make sure PAPIINC, PAPILIB are defined"
1595              DEFINES="$DEFINES -DUSE_PAPI"
1596              INCLUDES="$INCLUDES $PAPIINC"
1597              LIBS="$LIBS $PAPILIB"
1598          fi
1599    fi
1600    if test ! "x$PCL" = x ; then
1601          if test ! "x$PCLS" = x ; then
1602              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1603              echo "  Sticking with PCL flop summary per timestep!"
1604          else
1605              echo "  Turning on performance analysis with PCL"
1606              echo "  Please make sure PCLINC, PCLLIB are defined"
1607              DEFINES="$DEFINES -DUSE_PCL"
1608              INCLUDES="$INCLUDES $PCLINC"
1609              LIBS="$LIBS $PCLLIB"
1610          fi
1611    fi
1612    if test ! "x$HPMT" = x ; then
1613          if test ! "x$PAPI" = x ; then
1614              echo "  PAPI and the HPM Toolkit cannot co-exist!"
1615              echo "  Sticking with PAPI!"
1616          else if test ! "x$PCL" = x ; then
1617              echo "  PCL and the HPM Toolkit cannot co-exist!"
1618              echo "  Sticking with PCL!"
1619          else
1620              echo "  Turning on performance analysis with the HPM Toolkit"
1621              echo "  Please make sure HPMTINC, HPMTLIB are defined"
1622              DEFINES="$DEFINES -DUSE_LIBHPM"
1623              INCLUDES="$INCLUDES $HPMTINC"
1624              LIBS="$LIBS $HPMTLIB"
1625          fi
1626          fi
1627    fi
1628    if test ! "x$GSL" = x ; then
1629          echo "  Turning on use of GSL to control floating point calculations"
1630          echo "  Please make sure GSLINC, GSLLIB are defined"
1631          DEFINES="$DEFINES -DUSE_GSL_IEEE"
1632          INCLUDES="$INCLUDES $GSLINC"
1633          LIBS="$LIBS $GSLLIB"
1634    fi
1635    
1636  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1637  printf "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1638  cat > genmake_tcomp.$FS <<EOF  cat > genmake_tcomp.$FS <<EOF
# Line 1311  cat > genmake_tcomp.$FS <<EOF Line 1640  cat > genmake_tcomp.$FS <<EOF
1640        call system('echo hi')        call system('echo hi')
1641        end        end
1642  EOF  EOF
1643  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1644  RETVAL=$?  RETVAL=$?
1645  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1646      HAVE_SYSTEM=t      HAVE_SYSTEM=t
# Line 1326  rm -f genmake_tcomp* Line 1655  rm -f genmake_tcomp*
1655  printf "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1656  cat > genmake_tcomp.$FS <<EOF  cat > genmake_tcomp.$FS <<EOF
1657        program hello        program hello
1658        CHARACTER(128) string        CHARACTER*(128) string
1659        string = ' '        string = ' '
1660        call fdate( string )        call fdate( string )
1661        print *, string        print *, string
1662        end        end
1663  EOF  EOF
1664  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1665  RETVAL=$?  RETVAL=$?
1666  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1667      HAVE_FDATE=t      HAVE_FDATE=t
# Line 1354  cat > genmake_tcomp.$FS <<EOF Line 1683  cat > genmake_tcomp.$FS <<EOF
1683        print *, tarray        print *, tarray
1684        end        end
1685  EOF  EOF
1686  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1687  RETVAL=$?  RETVAL=$?
1688  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1689      HAVE_ETIME=t      HAVE_ETIME=t
# Line 1372  if test "x$HAVE_CLOC" != x ; then Line 1701  if test "x$HAVE_CLOC" != x ; then
1701      echo "yes"      echo "yes"
1702  else  else
1703      echo "no"      echo "no"
1704        if test "x$EMBED_SRC" = xt ; then
1705            echo "    WARNING: you requested file embedding but it has"
1706            echo "      been disabled since C code cannot be called"
1707            EMBED_SRC=
1708        fi
1709    fi
1710    rm -f genmake_t*
1711    
1712    printf "  Can we unlimit the stack size using $FC...  "
1713    check_HAVE_SETRLSTK
1714    if test "x$HAVE_SETRLSTK" = xt ; then
1715        echo "yes"
1716    else
1717        echo "no"
1718    fi
1719    rm -f genmake_t*
1720    
1721    printf "  Can we register a signal handler using $FC...  "
1722    check_HAVE_SIGREG
1723    if test "x$HAVE_SIGREG" = xt ; then
1724        echo "yes"
1725    else
1726        echo "no"
1727  fi  fi
1728  rm -f genmake_t*  rm -f genmake_t*
1729    
# Line 1393  else Line 1745  else
1745  fi  fi
1746  DEFINES="$DEFINES $IGNORE_TIME"  DEFINES="$DEFINES $IGNORE_TIME"
1747    
1748    if test "x$EMBED_SRC" = xt ; then
1749        build_embed_encode
1750    fi
1751    if test "x$EMBED_SRC" = xt ; then
1752        ENABLE="$ENABLE embed_files"
1753    fi
1754    
1755    
1756  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1757  printf "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1758  for d in $MODS ; do  for d in $MODS ; do
# Line 1478  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1838  if test -r $ROOTDIR"/eesupp/src/Makefile
1838      fi      fi
1839  fi  fi
1840    
1841  #same for exch2  #same for pkg/exch2 and pkg/regrid
1842  if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then  for pdir in exch2 regrid ; do
1843      echo "  Making source files in exch2 from  templates"      if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1844      ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1          echo "  Making source files in pkg/${pdir} from templates"
1845      RETVAL=$?          ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1846      if test "x${RETVAL}" = x0 ; then          RETVAL=$?
1847          rm -f make_exch2.errors          if test "x${RETVAL}" = x0 ; then
1848      else              rm -f make_${pdir}.errors
1849          echo "Error: problem encountered while building source files in exch2:"          else
1850          cat make_exch2.errors 1>&2              echo "Error: problem encountered while building source files in pkg/${pdir}:"
1851          exit 1              cat make_${pdir}.errors 1>&2
1852                exit 1
1853            fi
1854      fi      fi
1855  fi  done
1856    
1857  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1858  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
# Line 1601  done Line 1963  done
1963  rm -f ./.tmp_pack  rm -f ./.tmp_pack
1964  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1965    
1966  #  Check availability of NetCDF and then either build the MNC template  #  Check for package MNC: if NetCDF is available, then build the MNC
1967  #  files or delete mnc from the list of available packages.  #  template files ; otherwise, delete mnc from the list of packages.
1968  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1969  RETVAL=$?  RETVAL=$?
1970  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
# Line 1636  EOF Line 1998  EOF
1998      fi      fi
1999  fi  fi
2000    
2001    #  Check for package PROFILES: if NetCDF is not available,
2002    #  then delete profiles from the list of available packages.
2003    echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2004    RETVAL=$?
2005    if test "x$RETVAL" = x0 ; then
2006        if test "x$HAVE_NETCDF" != xt ; then
2007            cat <<EOF
2008    
2009    *********************************************************************
2010    WARNING: the "profiles" package was enabled but tests failed to
2011      compile NetCDF applications.  Please check that:
2012    
2013      1) NetCDF is correctly installed for this compiler and
2014      2) the LIBS variable (within the "optfile") specifies the correct
2015           NetCDF library to link against.
2016    
2017      Due to this failure, the "profiles" package is now DISABLED.
2018    *********************************************************************
2019    
2020    EOF
2021            PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2022            DISABLE="$DISABLE profiles"
2023        fi
2024    fi
2025    
2026  echo "  applying package dependency rules"  echo "  applying package dependency rules"
2027  ck=  ck=
2028  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
2029      i=0      i=0
2030      # rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
2031      rtot=$nname      rtot=$nname
2032      while test $i -lt $rtot ; do      while test $i -le $rtot ; do
2033    
2034          #  Is $pname in the current $PACKAGES list?          #  Is $pname in the current $PACKAGES list?
2035          #  pname=${PNAME[$i]}          #  pname=${PNAME[$i]}
# Line 1676  while test "x$ck" != xtt ; do Line 2063  while test "x$ck" != xtt ; do
2063    
2064          #  Do we need to add $dname according to the dependency rules?          #  Do we need to add $dname according to the dependency rules?
2065          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2066                #echo "   " $pname ": need to add :" $dname
2067              in_dis="f"              in_dis="f"
2068              for dis in $DISABLE ; do              for dis in $DISABLE ; do
2069                  if test "x$dis" = "x$dname" ; then                  if test "x$dis" = "x$dname" ; then
# Line 1844  for i in $INCLUDEDIRS ; do Line 2232  for i in $INCLUDEDIRS ; do
2232      fi      fi
2233  done  done
2234    
2235    if test ! "x$DIVA" = x ; then
2236        echo "  Creating the pseudo-MPI include directory"
2237        INCLUDES="-I./mpi_headers $INCLUDES"
2238        rm -rf ./mpi_headers
2239        mkdir -p ./mpi_headers
2240    
2241        if test "x$MPIINCLUDEDIR" = x ; then
2242            if test "x$MPIHOME" = x ; then
2243                MPIHOME='/usr'
2244            fi
2245            MPIINCLUDEDIR='$MPIHOME/include'
2246        fi
2247        
2248        if test -r $MPIINCLUDEDIR/mpif.h ; then
2249            for i in $MPI_HEADER_FILES; do
2250                cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2251            done
2252    
2253            perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2254        else
2255            echo " We cannot create a copy of mpif.h!"
2256    #       exit -1
2257        fi
2258    fi
2259    
2260  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2261  rm -rf .links.tmp  rm -rf .links.tmp
2262  mkdir .links.tmp  mkdir .links.tmp
2263    touch .links.tmp/foo
2264    if test ! -r ".links.tmp/foo" ; then
2265        echo
2266        echo "ERROR : something is wrong with your directory permissions or"
2267        echo "   your user file-creation mask (\"umask\") since creating a"
2268        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2269        echo "   not working.  Please try setting your umask to something"
2270        echo "   sane such as:"
2271        echo
2272        echo "      umask 0002"
2273        echo
2274        echo "   and please verify that you have the proper permissions for"
2275        echo "   creating sub-directories and then reading files created"
2276        echo "   within them."
2277        echo
2278        exit 1
2279    fi
2280    rm -f .links.tmp/foo
2281  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2282  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2283  printf 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
# Line 1862  for d in $alldirs ; do Line 2293  for d in $alldirs ; do
2293      for sf in $sfiles ; do      for sf in $sfiles ; do
2294          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
2295              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
2296                    ignore_f=f
2297                  case $d/$sf in                  case $d/$sf in
2298                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2299                            ignore_f=t
2300                          ;;                          ;;
2301                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2302                            ignore_f=t
2303                          ;;                          ;;
2304                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2305                            ignore_f=t
2306                          ;;                          ;;
2307                    ./BUILD_INFO.h)                    ./BUILD_INFO.h)
2308                            ignore_f=t
2309                            ;;
2310                      ./EMBEDDED_FILES.h)
2311                            ignore_f=t
2312                          ;;                          ;;
2313                    *)                    *)
2314                          touch .links.tmp/$sf                          #  For the local directory *ONLY*,
2315                          deplist="$deplist $sf"                          #  ignore all soft-links
2316                            if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2317                                ignore_f=t
2318                            else
2319                                touch .links.tmp/$sf
2320                                deplist="$deplist $sf"
2321                            fi
2322                          ;;                          ;;
2323                  esac                  esac
2324                  extn=`echo $sf | $AWK -F. '{print $NF}'`                  if test "x$ignore_f" = xf ; then
2325                  case $extn in                      extn=`echo $sf | $AWK -F. '{print $NF}'`
2326                      F)                      case $extn in
2327                          echo    " \\"  >> srclist.inc                          F)
2328                          printf " $sf" >> srclist.inc                              echo    " \\"  >> srclist.inc
2329                          ;;                              printf " $sf" >> srclist.inc
2330                      F90)                              ;;
2331                          echo    " \\"  >> f90srclist.inc                          F90)
2332                          printf " $sf" >> f90srclist.inc                              echo    " \\"  >> f90srclist.inc
2333                          ;;                              printf " $sf" >> f90srclist.inc
2334                      c)                              ;;
2335                          echo    " \\"  >> csrclist.inc                          c)
2336                          printf " $sf" >> csrclist.inc                              echo    " \\"  >> csrclist.inc
2337                          ;;                              printf " $sf" >> csrclist.inc
2338                      h)                              ;;
2339                          echo    " \\"  >> hlist.inc                          h)
2340                          printf " $sf" >> hlist.inc                              echo    " \\"  >> hlist.inc
2341                          ;;                              printf " $sf" >> hlist.inc
2342                      flow)                              ;;
2343                          echo    " \\"  >> ad_flow_files.inc                          flow)
2344                          printf " $sf" >> ad_flow_files.inc                              echo    " \\"  >> ad_flow_files.inc
2345                          ;;                              printf " $sf" >> ad_flow_files.inc
2346                  esac                              ;;
2347                        esac
2348                    fi
2349              fi              fi
2350          fi          fi
2351      done      done
# Line 1974  DISABLED_PACKAGES = ${DISABLED_PACKAGES} Line 2421  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2421    
2422  # These files are created by Makefile  # These files are created by Makefile
2423  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2424  EOF  EOF
2425    
2426  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2427        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2428    else
2429        echo "EMBEDDED_FILES = " >>$MAKEFILE
2430    fi
2431    
2432    #  Note: figure out some way to add Hyades JAM libraries here
2433  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2434  # Unix ln (link)  # Unix ln (link)
2435  LN = ${LN}  LN = ${LN}
# Line 2005  INCLUDES = ${INCLUDES} Line 2456  INCLUDES = ${INCLUDES}
2456  KFLAGS1 = ${KFLAGS1}  KFLAGS1 = ${KFLAGS1}
2457  KFLAGS2 = ${KFLAGS2}  KFLAGS2 = ${KFLAGS2}
2458  # Optim./debug for FC  # Optim./debug for FC
2459  FFLAGS = ${FFLAGS}  FFLAGS = ${FFLAGS} ${FEXTRAFLAGS}
2460  FOPTIM = ${FOPTIM}  FOPTIM = ${FOPTIM}
2461  # Optim./debug for FC  # Optim./debug for FC
2462  F90FLAGS = ${F90FLAGS}  F90FLAGS = ${F90FLAGS}
# Line 2029  cat hlist.inc         >> $MAKEFILE Line 2480  cat hlist.inc         >> $MAKEFILE
2480  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
2481  echo >> $MAKEFILE  echo >> $MAKEFILE
2482  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
2483  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.'$FS90')' >> $MAKEFILE
2484  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2485  echo >> $MAKEFILE  echo >> $MAKEFILE
2486  echo '.SUFFIXES:' >> $MAKEFILE  echo '.SUFFIXES:' >> $MAKEFILE
# Line 2040  rm -f ad_flow_files.inc Line 2491  rm -f ad_flow_files.inc
2491  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2492    
2493  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2494  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2495          @echo Creating \$@ ...          @echo Creating \$@ ...
2496          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2497  depend:  depend:
# Line 2049  depend: Line 2500  depend:
2500          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2501          -rm -f makedepend.out          -rm -f makedepend.out
2502    
2503    lib: libmitgcmuv.a
2504    
2505    libmitgcmuv.a: \$(OBJFILES)
2506            ar rcv libmitgcmuv.a \$(OBJFILES)
2507            ar d   libmitgcmuv.a main.o
2508    
2509  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2510    
2511  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
# Line 2058  output.txt: \$(EXECUTABLE) Line 2515  output.txt: \$(EXECUTABLE)
2515          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2516    
2517  clean:  clean:
2518          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2519            -rm -rf *.o
2520            -rm -rf *.$FS
2521  Clean:  Clean:
2522          @make clean          @make clean
2523          @make cleanlinks          @make cleanlinks
2524          -rm -f \$(SPECIAL_FILES)          -rm -f \$(SPECIAL_FILES)
2525          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
2526            -rm -f taf_command taf_output taf_ad.log taf_ad_flow.log
2527  CLEAN:  CLEAN:
2528          @make Clean          @make Clean
2529          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2530          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2531          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2532          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2533            -rm -f *_MIT_CE_000.opt0000 costfunction*0000
2534            -rm -rf mnc_test_*
2535    
2536  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2537  makefile:  makefile:
# Line 2097  test ! "x$THISUSER" = x && echo "      -echo Line 2559  test ! "x$THISUSER" = x && echo "      -echo
2559  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2560  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2561    
2562    if test "x$EMBED_SRC" = xt ; then
2563        cat >>$MAKEFILE <<EOF
2564    
2565    decode_files.o : EMBEDDED_FILES.h
2566    
2567    ##  \$(F77FILES)
2568    all_fF.tar.gz : \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2569            @echo Creating \$@ ...
2570            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2571            -rm -f all_fF.tar.gz
2572            -gzip all_fF.tar
2573    
2574    EMBEDDED_FILES.h : all_fF.tar.gz
2575            @echo Creating \$@ ...
2576            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2577    
2578    EOF
2579    fi
2580    
2581  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2582    
2583  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
# Line 2108  cat >>$MAKEFILE <<EOF Line 2589  cat >>$MAKEFILE <<EOF
2589          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2590  .$FS.o:  .$FS.o:
2591          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2592  .F90.$FS90:  .F90.o:  
         \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@  
 .$FS90.o:  
2593          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2594  .c.o:  .c.o:
2595          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2596    
2597  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2598  .F.p:  .F.p:
# Line 2137  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF Line 2616  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF
2616  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2617  for i in $ad_vars ; do  for i in $ad_vars ; do
2618      name=$i      name=$i
2619      t1="t2=\$"`echo $i`      t1="t2=\$"`echo "$i"`
2620      eval $t1      eval $t1
2621      printf "%-20s = " $name >> $MAKEFILE      printf "%-20s = " $name >> $MAKEFILE
2622      echo $t2 >> $MAKEFILE      echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2623  done  done
2624    
2625  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
# Line 2157  rm -f ad_files Line 2636  rm -f ad_files
2636  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2637    
2638  # ... AD ...  # ... AD ...
2639  adall: ad_taf  adall: \$(EXE_AD)
2640  adtaf: ad_taf_output.$FS  adtaf: ad_taf_output.$FS
2641  adtamc: ad_tamc_output.$FS  adtamc: ad_tamc_output.$FS
2642    
# Line 2177  adtafonly: Line 2656  adtafonly:
2656          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2657          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2658    
2659  ad_taf: ad_taf_output.o \$(OBJFILES)  \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2660          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2661    
2662  ad_tamc_output.$FS: ad_input_code.$FS  ad_tamc_output.$FS: ad_input_code.$FS
2663          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS

Legend:
Removed from v.1.125  
changed lines
  Added in v.1.167

  ViewVC Help
Powered by ViewVC 1.1.22